import { isVue3 as b, h as f, computed as U, defineComponent as H, toRef as Y, watch as Z, ref as N, onMounted as Be, nextTick as Le, onBeforeUnmount as ke, Vue2 as Ke } from "vue-demi";
import { createListenerPropsForwarder as G, pick as h, withDefaultProps as J, isHandlerKey as Me, toListenerKey as qe, isObject as $e, useListeners as He, useControlledState as Ge, isString as he, useManualEffect as Je, normalizeListenerKeys as V, mergeProps as A, isDef as Qe, isFunction as q } from "@visoning/vue-utility";
import { FloatingCreatorProps as je, FloatingCreator as ee } from "@visoning/vue-floating-core";
import { InteractorProps as Xe, createInteractorForwardContext as Ye, useInteractorForwardContext as Ze, Interactor as te } from "@visoning/vue-floating-interactions";
import { createInteractorForwardContext as lr, useInteractorForwardContext as ir } from "@visoning/vue-floating-interactions";
import { offset as et, shift as tt, flip as rt, autoPlacement as ot, arrow as nt } from "@floating-ui/core";
var at = Object.defineProperty, st = Object.defineProperties, lt = Object.getOwnPropertyDescriptors, re = Object.getOwnPropertySymbols, it = Object.prototype.hasOwnProperty, pt = Object.prototype.propertyIsEnumerable, oe = (e, t, r) => t in e ? at(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, W = (e, t) => {
  for (var r in t || (t = {}))
    it.call(t, r) && oe(e, r, t[r]);
  if (re)
    for (var r of re(t))
      pt.call(t, r) && oe(e, r, t[r]);
  return e;
}, ct = (e, t) => st(e, lt(t));
const xe = G(je, ["onFloatingDataUpdate"]), ut = h(je, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate"
]), De = h(Xe, [
  "interactions",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside"
]), Ee = {
  delay: [Number, Object],
  hoverDelay: [Number, Object],
  clickDelay: [Number, Object],
  focusDelay: [Number, Object]
}, dt = ct(W(W(W(W({}, ut), xe.props), De), Ee), {
  open: Boolean,
  defaultOpen: Boolean,
  disabled: Boolean,
  virtualElement: Object,
  appendTo: {},
  autoUpdateOnClosed: Boolean,
  offset: [Number, Object, Function],
  shift: [Boolean, Object],
  flip: [Boolean, Object],
  autoPlacement: [Boolean, Object],
  gpuAcceleration: Boolean,
  destoryedOnClosed: Boolean,
  floatingProps: Object,
  floatingWrapper: Function,
  popupProps: Object,
  popupWrapper: Function,
  zIndex: Number,
  "onUpdate:open": Function,
  onOpen: Function,
  onClose: Function
}), ft = {
  open: void 0,
  defaultOpen: !1,
  shift: !0,
  appendTo: "body"
}, Q = J(dt, ft);
var vt = Object.defineProperty, Pt = Object.defineProperties, _t = Object.getOwnPropertyDescriptors, z = Object.getOwnPropertySymbols, Se = Object.prototype.hasOwnProperty, Ce = Object.prototype.propertyIsEnumerable, ne = (e, t, r) => t in e ? vt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, k = (e, t) => {
  for (var r in t || (t = {}))
    Se.call(t, r) && ne(e, r, t[r]);
  if (z)
    for (var r of z(t))
      Ce.call(t, r) && ne(e, r, t[r]);
  return e;
}, Ot = (e, t) => Pt(e, _t(t)), mt = (e, t) => {
  var r = {};
  for (var a in e)
    Se.call(e, a) && t.indexOf(a) < 0 && (r[a] = e[a]);
  if (e != null && z)
    for (var a of z(e))
      t.indexOf(a) < 0 && Ce.call(e, a) && (r[a] = e[a]);
  return r;
};
function B(e, t, r) {
  if (r = Array.isArray(r) ? r : [r], b)
    return f(e, t.data, t.scopedSlots ? Ot(k({}, t.scopedSlots), {
      default: (...s) => {
        var u, _;
        return r.concat((_ = (u = t.scopedSlots) == null ? void 0 : u.default) == null ? void 0 : _.call(u, ...s));
      }
    }) : r);
  const a = t.data, {
    key: P,
    ref: $,
    class: j,
    style: i,
    scopedSlots: m
  } = a, p = mt(a, [
    "key",
    "ref",
    "class",
    "style",
    "scopedSlots"
  ]), g = {}, C = {}, o = {}, { propKeys: l } = t;
  for (const s in p)
    Me(s) ? g[qe(s)] = p[s] : l != null && l.includes(s) ? o[s] = p[s] : C[s] = p[s];
  return f(e, {
    key: P,
    ref: $,
    class: j,
    style: i,
    props: o,
    attrs: C,
    on: g,
    scopedSlots: k(k({}, m), t.scopedSlots)
  }, r);
}
let Fe, Ie, Te, Ne;
try {
  const e = require("vue");
  Fe = e.Transition, Ie = e.Teleport, Te = e.vShow, Ne = e.withDirectives;
} catch {
}
function gt(e) {
  return U(() => {
    const t = [];
    return e.offset && t.push(et(e.offset)), e.shift && t.push(tt(K(e.shift))), e.flip && t.push(rt(K(e.flip))), e.autoPlacement && t.push(ot(K(e.autoPlacement))), t.concat(e.middleware || []);
  });
}
function K(e, t = {}) {
  return $e(e) ? e : t;
}
var wt = Object.defineProperty, yt = Object.defineProperties, bt = Object.getOwnPropertyDescriptors, ae = Object.getOwnPropertySymbols, $t = Object.prototype.hasOwnProperty, ht = Object.prototype.propertyIsEnumerable, se = (e, t, r) => t in e ? wt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, y = (e, t) => {
  for (var r in t || (t = {}))
    $t.call(t, r) && se(e, r, t[r]);
  if (ae)
    for (var r of ae(t))
      ht.call(t, r) && se(e, r, t[r]);
  return e;
}, M = (e, t) => yt(e, bt(t));
function jt(e) {
  return Object.keys(e).reduce((t, r) => {
    const a = e[r];
    return t[r] = $e(a) ? { active: a.open, inactive: a.close } : a, t;
  }, {});
}
const le = {
  floating: "visoning-floating",
  popup: "visoning-popup"
}, ie = H({
  name: "VisoningPopup",
  inheritAttrs: !1,
  props: Q,
  setup(e, { slots: t, attrs: r, expose: a }) {
    const P = He(), [$, j] = Ge(Y(e, "open"), Y(e, "defaultOpen")), i = (n, d) => {
      j.value = n, n !== e.open && (P.emit("update:open", n, d), P.emit(n ? "open" : "close", d));
    }, m = Ye(), p = Ze(), g = U(() => m.interactor.value);
    Z(g, (n) => p == null ? void 0 : p.setInteractor(n));
    const C = U(() => e.virtualElement || g.value), o = N(), l = gt(e), s = N(), u = U(() => {
      const { appendTo: n } = e;
      return n === !1 ? g.value : he(n) ? document.querySelector(n) : n;
    });
    if (!b) {
      const n = () => {
        const { value: O } = u;
        if (!O)
          return;
        const v = new Ke({
          render() {
            return s.value;
          }
        });
        return v.$mount(), O.appendChild(v.$el), () => {
          var w;
          v.$destroy(), (w = v.$el) == null || w.remove();
        };
      }, { clear: d, reset: c } = Je(n);
      Z(u, () => c()), Be(() => void Le(c)), ke(() => d());
    }
    const _ = N();
    a({
      getElements: () => ({
        floating: o.value,
        reference: g.value
      }),
      updatePosition: () => {
        var n;
        return (n = _.value) == null ? void 0 : n.updatePosition();
      },
      getFloatingData: () => {
        var n;
        return (n = _.value) == null ? void 0 : n.getFloatingData();
      }
    });
    const D = ({
      x: n,
      y: d,
      strategy: c,
      middlewareData: O
    }) => {
      const v = e.gpuAcceleration ? {
        top: 0,
        left: 0,
        transform: `translate3d(${n}px, ${d}px, 0px)`
      } : {
        top: `${d}px`,
        left: `${n}px`
      }, w = M(y({}, v), {
        position: c,
        zIndex: e.zIndex
      });
      return O.hide && !O.hide.referenceHidden && (w.visibility = "hidden"), w;
    }, F = (n, d) => {
      let c = B("div", {
        data: A(e.floatingProps, {
          ref: o,
          class: le.floating,
          style: D(n)
        })
      }, [d]);
      if (e.floatingWrapper && (c = e.floatingWrapper(c)), b)
        return f(Ie, {
          to: u.value
        }, {
          default: () => [c]
        });
      s.value = c;
    }, R = (n) => {
      var d;
      const { value: c } = $, { destoryedOnClosed: O } = e;
      if (!c && O)
        return;
      const { popupProps: v, popupWrapper: w } = e, E = B("div", {
        data: A(v, {
          class: le.popup
        })
      }, (d = t.default) == null ? void 0 : d.call(t, n));
      if (b)
        Ne(E, [[Te, c, "show"]]);
      else {
        const L = {
          name: "show",
          value: c
        };
        (E.data.directives || (E.data.directives = [])).push(L);
      }
      return w ? w(E) : E;
    }, ze = (n) => {
      var d;
      const c = M(y(y({}, h(e, Object.keys(De))), jt(h(e, Object.keys(Ee)))), {
        active: $.value,
        targets: [o.value].filter(Qe)
      }), O = {
        "onUpdate:active": i
      }, v = (d = t.reference) == null ? void 0 : d.call(t);
      return b ? f(te, y(y(y({}, r), c), O), [v, n]) : f(te, {
        attrs: r,
        props: c,
        on: V(O)
      }, v);
    };
    return () => {
      const n = e.disabled || !$.value && !e.autoUpdateOnClosed, d = {
        ref: _
      }, c = {
        reference: C.value,
        floating: o.value,
        disabled: n,
        placement: e.placement,
        strategy: e.strategy,
        autoUpdate: e.autoUpdate,
        middleware: l.value
      }, O = xe.forwards(), v = {
        default: (w) => {
          const E = R(w), L = F(w, E);
          return ze(L);
        }
      };
      return b ? f(ee, y(y(y({}, c), O), d), v) : f(ee, M(y({}, d), {
        props: c,
        on: V(O),
        scopedSlots: v
      }));
    };
  }
});
var xt = Object.defineProperty, Dt = Object.defineProperties, Et = Object.getOwnPropertyDescriptors, pe = Object.getOwnPropertySymbols, St = Object.prototype.hasOwnProperty, Ct = Object.prototype.propertyIsEnumerable, ce = (e, t, r) => t in e ? xt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, ue = (e, t) => {
  for (var r in t || (t = {}))
    St.call(t, r) && ce(e, r, t[r]);
  if (pe)
    for (var r of pe(t))
      Ct.call(t, r) && ce(e, r, t[r]);
  return e;
}, Ft = (e, t) => Dt(e, Et(t));
const Ae = G(Q, ["onFloatingDataUpdate", "onUpdate:open", "onOpen", "onClose"]), Re = h(Q, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "interactions",
  "delay",
  "hoverDelay",
  "clickDelay",
  "focusDelay",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "floatingProps",
  "floatingWrapper",
  "zIndex"
]), It = Ft(ue(ue({}, Re), Ae.props), {
  title: [String, Function],
  content: [String, Function],
  theme: String,
  size: String,
  transitionProps: [String, Object],
  showArrow: Boolean,
  arrow: Function,
  arrowProps: Object,
  popoverProps: Object,
  contentProps: Object,
  popoverWrapper: Function
}), Ue = "visoning-popover", Tt = {
  theme: "line",
  size: "meduim",
  transitionProps: Ue,
  showArrow: !0
}, X = J(It, Tt);
var Nt = Object.defineProperty, At = Object.defineProperties, Rt = Object.getOwnPropertyDescriptors, de = Object.getOwnPropertySymbols, Ut = Object.prototype.hasOwnProperty, Wt = Object.prototype.propertyIsEnumerable, fe = (e, t, r) => t in e ? Nt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, S = (e, t) => {
  for (var r in t || (t = {}))
    Ut.call(t, r) && fe(e, r, t[r]);
  if (de)
    for (var r of de(t))
      Wt.call(t, r) && fe(e, r, t[r]);
  return e;
}, ve = (e, t) => At(e, Rt(t));
const I = {
  popover: "visoning-popover",
  content: "visoning-popover-content",
  title: "visoning-popover-title",
  arrow: "visoning-popover-arrow",
  dark: "theme-dark"
}, Pe = H({
  name: "VisoningPopover",
  inheritAttrs: !1,
  props: X,
  setup(e, { attrs: t, expose: r, slots: a }) {
    const P = N(), $ = ({
      placement: o,
      middlewareData: l
    }) => {
      var s, u, _, x;
      const D = (u = (s = l.arrow) == null ? void 0 : s.y) != null ? u : 0, F = (x = (_ = l.arrow) == null ? void 0 : _.x) != null ? x : 0, R = {
        "--vp-arrow-top": `${D}px`,
        "--vp-arrow-left": `${F}px`
      };
      return o.includes("top") || o.includes("bottom") ? R.left = `${F}px` : R.top = `${D}px`, R;
    }, j = (o) => {
      const l = e.arrow || a.arrow;
      return l ? l(o) : f("div", {
        ref: P,
        class: I.arrow,
        style: $(o)
      });
    }, i = U(() => {
      const o = e.middleware || [];
      return e.showArrow && P.value && o.push(nt({
        element: P.value
      })), o;
    }), m = (o) => {
      const { transitionProps: l } = e;
      if (l) {
        const s = he(l) ? { name: l } : S({
          name: Ue
        }, l);
        if (b) {
          const u = o;
          o = f(Fe, s, {
            default: () => u
          });
        } else
          o = f("transition", {
            props: s
          }, [o]);
      }
      return e.popoverWrapper ? e.popoverWrapper(o) : o;
    }, p = N();
    r({
      updatePosition: () => {
        var o;
        return (o = p.value) == null ? void 0 : o.updatePosition();
      },
      getFloatingData: () => {
        var o;
        return (o = p.value) == null ? void 0 : o.getFloatingData();
      },
      getElements: () => {
        var o;
        return ((o = p.value) == null ? void 0 : o.getElements()) || {};
      }
    });
    const C = (o) => {
      var l, s, u;
      const _ = (l = e.title) != null ? l : a.title, x = (u = (s = e.content) != null ? s : a.content) != null ? u : a.default, D = q(_) ? _() : _, F = q(x) ? x() : x;
      return B("div", {
        data: A(e.popoverProps, {
          class: [
            I.popover,
            `size-${e.size}`,
            e.theme === "dark" && I.dark
          ],
          "data-placement": o.placement
        })
      }, [
        B("div", {
          data: A(e.contentProps, {
            class: I.content
          })
        }, [
          D && f("div", {
            class: I.title
          }, [D]),
          F
        ]),
        e.showArrow && j(o)
      ]);
    };
    return () => {
      const o = {
        ref: p
      }, l = ve(S({}, h(e, Object.keys(Re))), {
        middleware: i.value,
        popupWrapper: m,
        popupProps: A(e.popoverProps, {
          class: I.popover
        })
      }), s = Ae.forwards(), u = {
        reference: a.reference,
        default: C
      };
      return b ? f(ie, S(S(S(S({}, t), l), s), o), u) : f(ie, ve(S({}, o), {
        props: l,
        on: V(s),
        attrs: t,
        scopedSlots: u
      }));
    };
  }
});
var Vt = Object.defineProperty, zt = Object.defineProperties, Bt = Object.getOwnPropertyDescriptors, _e = Object.getOwnPropertySymbols, Lt = Object.prototype.hasOwnProperty, kt = Object.prototype.propertyIsEnumerable, Oe = (e, t, r) => t in e ? Vt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, me = (e, t) => {
  for (var r in t || (t = {}))
    Lt.call(t, r) && Oe(e, r, t[r]);
  if (_e)
    for (var r of _e(t))
      kt.call(t, r) && Oe(e, r, t[r]);
  return e;
}, Kt = (e, t) => zt(e, Bt(t));
const We = G(X, ["onFloatingDataUpdate", "onUpdate:open", "onOpen", "onClose"]), Ve = h(X, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "interactions",
  "delay",
  "hoverDelay",
  "clickDelay",
  "focusDelay",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "floatingProps",
  "floatingWrapper",
  "zIndex",
  "content",
  "theme",
  "size",
  "transitionProps",
  "showArrow",
  "arrow",
  "arrowProps",
  "contentProps"
]), Mt = Kt(me(me({}, Ve), We.props), {
  textAlign: String,
  tooltipProps: Object,
  tooltipWrapper: Function
}), qt = {
  interactions: "hover",
  theme: "drak",
  textAlign: "start",
  allowPointerEnterTarget: !1
}, Ht = J(Mt, qt);
var Gt = Object.defineProperty, Jt = Object.defineProperties, Qt = Object.getOwnPropertyDescriptors, ge = Object.getOwnPropertySymbols, Xt = Object.prototype.hasOwnProperty, Yt = Object.prototype.propertyIsEnumerable, we = (e, t, r) => t in e ? Gt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, T = (e, t) => {
  for (var r in t || (t = {}))
    Xt.call(t, r) && we(e, r, t[r]);
  if (ge)
    for (var r of ge(t))
      Yt.call(t, r) && we(e, r, t[r]);
  return e;
}, ye = (e, t) => Jt(e, Qt(t));
const be = {
  tooltip: "visoning-tooltip",
  content: "visoning-tooltip-content"
}, nr = H({
  name: "Tooltip",
  inheritAttrs: !1,
  props: Ht,
  setup(e, { attrs: t, slots: r, expose: a }) {
    const P = N();
    a({
      updatePosition: () => {
        var i;
        return (i = P.value) == null ? void 0 : i.updatePosition();
      },
      getFloatingData: () => {
        var i;
        return (i = P.value) == null ? void 0 : i.getFloatingData();
      },
      getElements: () => {
        var i;
        return ((i = P.value) == null ? void 0 : i.getElements()) || {};
      }
    });
    const j = () => {
      var i, m;
      const p = (m = (i = e.content) != null ? i : r.content) != null ? m : r.default;
      return f("div", {
        style: {
          textAlign: e.textAlign
        }
      }, [
        f("span", {
          class: be.content
        }, [q(p) ? p() : p])
      ]);
    };
    return () => {
      const i = {
        ref: P
      }, m = ye(T({}, h(e, Object.keys(Ve))), {
        popoverProps: A(e.tooltipProps, {
          class: be.tooltip
        }),
        popoverWrapper: e.tooltipWrapper
      }), p = We.forwards(), g = {
        reference: r.reference,
        arrow: r.arrow,
        content: j
      };
      return b ? f(Pe, T(T(T(T({}, t), m), p), i), g) : f(Pe, ye(T({}, i), {
        props: m,
        on: V(p),
        attrs: t,
        scopedSlots: g
      }));
    };
  }
});
export {
  Pe as Popover,
  I as PopoverClassNames,
  Tt as PopoverDefaultProps,
  X as PopoverProps,
  It as PopoverPropsType,
  Ue as PopoverTransitionName,
  ie as Popup,
  ft as PopupDefaultProps,
  Q as PopupProps,
  dt as PopupPropsType,
  nr as Tooltip,
  be as TooltipClassNames,
  qt as TooltipDefaultProps,
  Ht as TooltipProps,
  Mt as TooltipPropsType,
  lr as createInteractorForwardContext,
  ir as useInteractorForwardContext
};
